!*********************************************
!ITERATIONS ON PRICES
!*********************************************


SUBROUTINE iterations



use mod_types
use mod_param
use mod_computation
use mod_utils
use mod_functions
use NUMERICAL_LIBRARIES


implicit none

integer::is,ik,ih,iter,j1,tm,il,age,iy,iyy
real(dp)::SSEk,SSTk,coefdif,Rsquared,SSEh,SSTh,SSEl,SSTl
real(dp),allocatable::oldcoefK(:),oldcoefL(:)
real(dp),dimension(2)::regs

!xxx Kgrid change
real(dp)::minK,maxK   !min and max on Kgrid

!character(8)::hour


open (unit = 9131567, file = 'intermediate_coeffKs.txt', status="replace")
close (unit=9131567)
open (unit = 9131567, file = 'intermediate_coeffLs.txt', status="replace")
close (unit=9131567)
open (unit = 91411, file = 'intermediate_minK.txt', status="replace")
close (unit=91411)
open (unit = 91421, file = 'intermediate_maxK.txt', status="replace")
close (unit=91421)



!allocate regression coefficients to store values
allocate(oldcoefK(2*ns),oldcoefL(2*ns))


EV=0.0_dp

coefK=coefK_ini
coefL=coefL_ini

!xxx KoverLgrid change
!initialization of minK and maxK
maxK= span_k+iniK
minK=-span_k+iniK


do iter=1,max_iter

oldcoefK(:)=coefK(:)
oldcoefL(:)=coefL(:)

open (unit = 91411, file = 'intermediate_minK.txt',position='append')
write (91411,  '(f16.4)') (minK)
close (unit=91411)
open (unit = 91421, file = 'intermediate_maxK.txt',position='append')
write (91421,  '(f16.4)') (maxK)
close (unit=91421)
open (unit = 91410, file = 'exp_pens.txt',status='replace')
close (unit= 91410)
open (unit = 91513, file = 'exp_inc.txt', status='replace')
close (unit=91513)


call Kgrid_generation(minK,maxK)


!***************************************************
!given coefK and KoverL_grid, find next period capital
!***************************************************
do ik=1,nk
do is=1,ns

regs(:)=REGGAMMA(is,K_grid(ik))
KPRIME(is,ik)=regs(1)
LPRIME(is,ik)=regs(2)

!prices for grid:
R(is,ik)=interest(is,K_grid(ik),LPRIME(is,ik))
Wa(is,ik)=wage(is,K_grid(ik),LPRIME(is,ik))   


call basefun (K_grid,nk,KPRIME(is,ik),valsKP(:,is,ik),indsKP(:,is,ik))

!***********************************************
!EXPECTED (DISCOUNTED) STREAM OF FUTURE INCOMES
!***********************************************

!*************
!RETIRED
!*************

!expected pension at max_age
exp_pens(max_age-ret_age+1,is,ik)=ybar(max_age)

do age=max_age-1,ret_age,-1
!expected future stream of pensions, discounted at R(shock,ik)
exp_pens(age-ret_age+1,is,ik)=ybar(age)+p_surv(age)*exp_pens(age-ret_age+2,is,ik)/R(is,ik)
enddo

open (unit = 91410, file = 'exp_pens.txt',position='append')
do age=ret_age,max_age
write (91410,'(f16.4)') (exp_pens(age-ret_age+1,is,ik))
enddo
close (unit=91410)

!****************
!WORKERS
!****************

!a piece of the expected discounted stream of incomes at ret_age-1
do iy=1,nny
exp_inc(ret_age,(is-1)*nny+iy,ik)=exp_pens(1,is,ik)
enddo

enddo  !end is
enddo  !end ik


!expected discounted future stream of incomes:

do age=ret_age-1,1,-1
do ik=1,nk
!for each current idio shock
do iy=1,ny
exp_inc(age,iy,ik)=0.0_dp
!for each future combination of idio and aggr shocks:
do iyy=1,ny
exp_inc(age,iy,ik)=exp_inc(age,iy,ik)+payay(iy,iyy)*exp_inc(age+1,iyy,ik)
enddo
exp_inc(age,iy,ik)=Wa(index_Ags(iy),ik)*zy(index_y(iy))*eta(age)+p_surv(age)*exp_inc(age,iy,ik)/R(index_Ags(iy),ik)  
enddo
enddo  !end ik
enddo  !end age




open (unit = 91513, file = 'exp_inc.txt',position='append')
do ik=1,nk
do iy=1,ny
do age=1,ret_age
write (91513,'(f16.4)') (exp_inc(age,iy,ik))
enddo
enddo
enddo
close (unit=91513)


!open (unit = 2000, file = 'time.txt', position='append')

!call time (hour)
!write (2000,*) "Value Iter Starts at:"
!write (2000,*) (hour)

!close (unit = 2000)

!solve for value function
call value_iter

!pause

!open (unit = 2000, file = 'time.txt', position='append')

!call time (hour)
!write (2000,*) "Simul1 Starts at:"
!write (2000,*) (hour)

!close (unit = 2000)

!simulate the dynamics of the distribution of assets
call simul1


!open (unit = 2000, file = 'time.txt', position='append')

!call time (hour)
!write (2000,*) "Regressions Start at:"
!write (2000,*) (hour)

!close (unit = 2000)

!******************************************************
!REGRESSION
!******************************************************

call DRLSE(time_length-TAC-1,dipK(2:time_length-TAC),2*ns,exxe(1:(time_length-TAC-1),1:2*ns),time_length-TAC-1,0,coefK,SSTk,SSEk)
call DRLSE(time_length-TAC-1,dipL(2:time_length-TAC),2*ns,exxe(1:(time_length-TAC-1),1:2*ns),time_length-TAC-1,0,coefL,SSTl,SSEl)

Rsquared=1.0_dp-SSEk/SSTk

print*, "coefK="
print '(f16.4)', coefK(:)

print*, "Rsquared k=",Rsquared

open (unit = 9131, file = 'intermediate_coeffKs.txt', position="append")
write (9131,*) (iter)
write (9131,  '(f16.4)') (coefK)
write (9131, '(f16.4)') (Rsquared)
close (unit=9131)


Rsquared=1.0_dp-SSEl/SSTl

print*, "coefL="
print '(f16.4)',coefL(:)

print*, "Rsquared l=",Rsquared

open (unit = 9131, file = 'intermediate_coeffLs.txt', position="append")
write (9131,*) (iter)
write (9131,  '(f16.4)') (coefL)
write (9131, '(f16.4)') (Rsquared)
close (unit=9131)



open (unit = 9141, file = 'exxe.txt')
write (9141,  '(f16.4)') (exxe)
close (unit=9141)

open (unit = 9141, file = 'dipK.txt')
write (9141,  '(f16.4)') (dipK)   
close (unit=9141)

open (unit = 9141, file = 'dipL.txt')
write (9141,  '(f16.4)') (dipL)   
close (unit=9141)

coefdif=dmax1(sum(dabs(coefK(:)-oldcoefK(:))),sum(dabs(coefL(:)-oldcoefL(:))))

if (coefdif<smallino) then
exit
endif

coefK(:)=0.25_dp*coefK(:)+0.75_dp*oldcoefK(:)
coefL(:)=0.25_dp*coefL(:)+0.75_dp*oldcoefL(:)

!open (unit = 2000, file = 'time.txt', position='append')

!call time (hour)
!write (2000,*) "End Regressions at:"
!write (2000,*) (hour)

!close (unit = 2000)

!pause

!xxx KoverLgrid change

print*, 'min value of dipK is', minval(dipK(1:time_length-TAC))
print*, 'max value of dipK is', maxval(dipK(1:time_length-TAC))

minK=wKold*minK+(1.0_dp-wKold)*minval(dipK(1:time_length-TAC))
maxK=wKold*maxK+(1.0_dp-wKold)*maxval(dipK(1:time_length-TAC))


enddo


if (allocated(oldcoefK)) deallocate(oldcoefK)
if (allocated(oldcoefL)) deallocate(oldcoefL)

END SUBROUTINE iterations
