!*************************************************
!SUBROUTINE THAT COMPUTES VALUE FUNCTION
!AND POLICY FUNCTION THROUGH POLICY FUNCTION
!ITERATION
!*************************************************


!**************
!Marina Pavan
!May 17 2005
!**************


SUBROUTINE value_iter

use mod_types
use mod_computation
use mod_functions
use mod_utils

implicit none 


!variables:

real(dp)::v_fo,v_fr  !value of owning a house, value of renting

real(dp), dimension(fulnh)::vtemp  !objective function to maximize, as a function of choices hprime
real(dp)::y0,c0,c1,c11,c2,c,inc,KP !consumption, collateral constraint

real(dp)::hprice  !price of renting given R(shock,K)

real(dp)::Einterest,E1,E2  !expected gross interest rate
integer:: age,ih,ib,ih0,ib0,iy0,iy,iter,ik,iac  !,ihh !counters

real(dp)::vtempp,cp,vtemppr,cpr
real(dp)::t1,t2

integer,dimension(1)::index_p  !index of optimal value for h
integer, dimension(fulnh)::index_pp !index of optimal value for b given h
integer::index_ppr  !index of optimal b' given state b

real(dp),dimension(nb(1))::Co1,pol_l1
real(dp),dimension(nb(2))::Co2,pol_l2



!Initializations:
!****************


EV=0.0_dp
Vtemp=0.0_dp
c=0.0_dp
pol_h=0
pol_b=0
index_p=0

!*********************************
!LAST VALUE:
!*********************************

CALL last_value

CALL ret_value


!*********************************
!VALUE FUNCTION BACKWARD SOLUTION:
!*********************************

DO 	age=ret_age-1,1,-1

    call cpu_time(t1) ! toc

    !do ihh=1,nhh  !for any value of aggregate housing
	
	do ik=1,nk  !for any value of aggregate K
	

	do iy=1,nybz  !income (idiosyncratic + aggregate) & beta
        
        do ih0=1,nh(index_beta(iy))  !for each ih (choice) approximate EV
        
 		
		EV(ih0,1:nb(index_beta(iy)))=(valsKP(1,index_Ags(iy),ik)*matmul(pbzyy(iy,:),transpose(v_f(age+1,ih0,1:nb(index_beta(iy)),:,indsKP(1,index_Ags(iy),ik))))+&
		 valsKP(2,index_Ags(iy),ik)*matmul(pbzyy(iy,:),transpose(v_f(age+1,ih0,1:nb(index_beta(iy)),:,indsKP(2,index_Ags(iy),ik)))))
		enddo  !end ih0

		!artigianale:
		E1=0.0_dp
		E2=0.0_dp
		do iac=1,ns
		E1=E1+pAA(index_Ags(iy),iac)*R(iac,indsKP(1,index_Ags(iy),ik))
		E2=E2+pAA(index_Ags(iy),iac)*R(iac,indsKP(2,index_Ags(iy),ik))
		enddo

		Einterest=valsKP(1,index_Ags(iy),ik)*E1+valsKP(2,index_Ags(iy),ik)*E2

		!house price given shock and K:
		!hprice=R(K)-1+delta_h
		!hprice=R(index_Ags(iy),ik)-idelta
		hprice=1.0_dp-idelta/Einterest
		         	     
	    !this period earnings:
		inc=Wa(index_Ags(iy),ik)*zy(index_Azy(iy))*eta(age)
		
		do ih0=1,nh(index_beta(iy))    !for any possible value of state h

            !*********************************************************
            !NOTE: TO COMPUTE CONSUMPTION FROM BUDGET CONSTRAINT
            !I TAKE INTO CONSIDERATION OPTIMAL RULE TO CHOOSE HOURS:
            !CONSUMPTION=(CASH-ON-HAND+CHOICES)/(1+TAU)
            !*********************************************************    
			c0=h(ih0,(index_beta(iy)))*idelta+inc*lbar-tax

			index_pp(:)=nb(index_beta(iy))  !set index_b equal to lowest b (search everywhere)
			index_ppr=nnb(index_beta(iy))  !lowest b is 0 if renting

			do ib0=nb(index_beta(iy)),1,-1  !for any possible value of state b
			
			!if degenerate index_ppr, go back to max index
			if (index_ppr==1) then 
				index_ppr=nnb(index_beta(iy)) 
			endif


			c11=c0-b(ib0,(index_beta(iy)))*(R(index_Ags(iy),ik)+ind_b(ib0,index_beta(iy))*rpremium)
            
 
			do ih=1,nh(index_beta(iy))  ! for any possible choice of h
				
				!if degenerate index_pp, go back to max index
				if (index_pp(ih)==1) then 
					index_pp(ih)=nb(index_beta(iy)) 
				endif
			
			    if (dabs(h(ih,(index_beta(iy)))/h(ih0,(index_beta(iy)))-1.0_dp)>frach) then 
		
				c1=c11-h(ih,(index_beta(iy)))-costh*h(ih0,(index_beta(iy)))  !cash-on-hand minus the expenditure for the house-transaction cost
				
				else
				
				c1=c11-h(ih,(index_beta(iy)))
				
				endif

					!initialize value f. for index b = index_b(ih)  (lowest possible b given choice ih)

						if (b(index_pp(ih),(index_beta(iy)))<=dmin1(coll(ih,(index_beta(iy))),minco*exp_inc(age,(index_Ags(iy)-1)*nny+index_Azy(iy),ik))) then

						c=dmax1(c1+b(index_pp(ih),(index_beta(iy))),cmin)/itau(age)

						else

						c=cmin/itau(age)

						endif

						Vtemp(ih)=wbeta(index_beta(iy),age)*utility(index_beta(iy),c,h(ih,index_beta(iy)),inc,age)+betta(index_beta(iy),age)*p_surv(age)*EV(ih,index_pp(ih)) 
						cp=c
						

					do ib=index_pp(ih)-1,1,-1  !for any possible choice of b>1

						!feasible?

						if (b(ib,(index_beta(iy)))<=dmin1(coll(ih,(index_beta(iy))),minco*exp_inc(age,(index_Ags(iy)-1)*nny+index_Azy(iy),ik))) then


						c=dmax1(c1+b(ib,(index_beta(iy))),cmin)/itau(age)

						else

						c=cmin/itau(age)

						endif
                        
						Vtempp=wbeta(index_beta(iy),age)*utility(index_beta(iy),c,h(ih,(index_beta(iy))),inc,age)+betta(index_beta(iy),age)*p_surv(age)*EV(ih,ib)
					
						
						if (Vtempp<Vtemp(ih) .and. cp>cmin/itau(age)) then

						exit

						endif
						
						Vtemp(ih)=Vtempp
						index_pp(ih)=ib
						cp=c


					enddo  !end b choice

					

			enddo  !end h choice


			!******************************
			!value of owning a house:
			!******************************
			v_fo=maxval(Vtemp(1:nh(index_beta(iy))))


			!***************************************************************************
			!2) COMPUTE VALUE OF RENTING A HOUSE: CHOICE IS B, 
			!	H IS INTRA-TEMPORAL DECISION TAKEN INTO ACCOUNT IN BUDGET CONSTRAINT
			!***************************************************************************

			!*****************************************
			!value of renting a house is V_fr
			!*****************************************

			!initialize value of renting at index_ppr (lowest possible choice, exploiting monotonicity):

            c=dmax1((c11-costh*h(ih0,(index_beta(iy)))+b(index_ppr,(index_beta(iy))))/(itau(age)+whouse(age)),cmin)
			
            
			!utility for tenants:
			V_fr=wbeta(index_beta(iy),age)*utility_ten(index_beta(iy),c,hprice,inc,age)+betta(index_beta(iy),age)*p_surv(age)*EV(1,index_ppr)
			cpr=c

			!choose b:
			do ib=index_ppr-1,1,-1

			c=dmax1((c11-costh*h(ih0,(index_beta(iy)))+b(ib,(index_beta(iy))))/(itau(age)+whouse(age)),cmin)

			Vtemppr=wbeta(index_beta(iy),age)*utility_ten(index_beta(iy),c,hprice,inc,age)+betta(index_beta(iy),age)*p_surv(age)*EV(1,ib)
			
			!exploit concavity:	
			if (Vtemppr<V_fr .and. cpr>cmin) then

			exit

			endif
						
			V_fr=Vtemppr
			index_ppr=ib
			cpr=c

			enddo

			!**************************************
			!IF OWNING LEADS TO HIGHER VALUE:
			!**************************************

			if (v_fo>=v_fr) then

			v_f(age,ih0,ib0,iy,ik)=v_fo  !max value
			index_p=maxloc(Vtemp(1:nh(index_beta(iy))))		!index of maximizer
			pol_h(age,ih0,ib0,iy,ik)=index_p(1)  !optimal choice of house for state 
			pol_b(age,ih0,ib0,iy,ik)=index_pp(index_p(1))  !optimal choice of debt for
			

			!**************************************
			!IF RENTING LEADS TO HIGHER VALUE:
			!**************************************

			else

			v_f(age,ih0,ib0,iy,ik)=v_fr  !max value
			pol_h(age,ih0,ib0,iy,ik)=1 !house=0
			pol_b(age,ih0,ib0,iy,ik)=index_ppr  !optimal choice of debt for
            
			endif
			

			
		enddo !end b state

		
		enddo !end h state

	enddo  !end y loop
	
	enddo  !end capital loop

!	enddo  !end h aggregate loop


    call cpu_time(t2) ! toc
    print*, 'age=', age, ';   Time (sec) between calls of cpu_time: ',t2-t1

			!********************************************
			!policies saved as indexes:
			!FOR MEDIAN AGGR K and average idio shock
			!********************************************

			open (unit = 91410, file = 'pol_b_11.txt', position='append')  !worst aggr state, impatient
			open (unit = 91411, file = 'pol_b_12.txt', position='append')   !worst aggr state, patient
			open (unit = 91412, file = 'pol_b_21.txt', position='append')  !best aggr state, impatient
			open (unit = 91413, file = 'pol_b_22.txt', position='append')   !best aggr state, patient
			open (unit = 91414, file = 'pol_b_m1.txt', position='append')   !average shocks, impatient
			open (unit = 91415, file = 'pol_b_m2.txt', position='append')   !average shocks, patient
			open (unit = 91510, file = 'pol_h_11.txt', position='append')
			open (unit = 91511, file = 'pol_h_12.txt', position='append')
			open (unit = 91512, file = 'pol_h_21.txt', position='append')
			open (unit = 91513, file = 'pol_h_22.txt', position='append')
    		open (unit = 91514, file = 'pol_h_m1.txt', position='append')
			open (unit = 91515, file = 'pol_h_m2.txt', position='append')
			open (unit = 91610, file = 'pol_l_11.txt', position='append')
			open (unit = 91611, file = 'pol_l_12.txt', position='append')
			open (unit = 91612, file = 'pol_l_21.txt', position='append')
			open (unit = 91613, file = 'pol_l_22.txt', position='append')
			open (unit = 91614, file = 'pol_l_m1.txt', position='append')
			open (unit = 91615, file = 'pol_l_m2.txt', position='append')
            
            ik=idnint(nk/2.0_dp)
            
            
			!IMPATIENT GUY
			do ih0=1,nh(1)
			    !WORST AGGREGATE SHOCK, AVERAGE IDIO SHOCK:
			    iy=idnint((nny+1.0_dp)/2.0_dp)
			    hprice=R(index_Ags(iy),ik)-idelta
			    inc=Wa(index_Ags(iy),ik)*zy(index_Azy(iy))*eta(age)
			 	
				!COMPUTE OPTIMAL LABOR
			    !CONSUMPTION:
		        do ib0=1,nb(1)
		            !owner
			        if (pol_h(age,ih0,ib0,iy,ik)>1) then
			            Co1(ib0)=dmax1(-b(ib0,1)*(R(index_Ags(iy),ik)+ind_b(ib0,index_beta(iy))*rpremium)+h(ih0,1)*idelta+&
			            inc*lbar+b(pol_b(age,ih0,ib0,iy,ik),1)-h(pol_h(age,ih0,ib0,iy,ik),1)-tax,cmin)/itau(age)
			            if (dabs(h(pol_h(age,ih0,ib0,iy,ik),1)/h(ih0,1)-1.0_dp)>frach) then
				        Co1(ib0)=dmax1(cmin,Co1(ib0)-costh*h(ih0,1)/itau(age))
				        endif 
				    !renter      		
			        else
			        Co1(ib0)=dmax1(-b(ib0,1)*(R(index_Ags(iy),ik)+ind_b(ib0,index_beta(iy))*rpremium)+h(ih0,1)*(idelta-costh)+&
			            inc*lbar+b(pol_b(age,ih0,ib0,iy,ik),1)-tax,cmin)/(itau(age)+whouse(age))
				    endif 
				enddo     
				pol_l1(:)=dmax1(0.001_dp,lbar-tau(age)*Co1(:)/inc)  
			    
			    write (91410,'(I3)') (pol_b(age,ih0,1:nb(1),iy,ik))
				write (91510,'(I3)') (pol_h(age,ih0,1:nb(1),iy,ik))
			    write (91610,'(f16.4)') (pol_l1(:))
			    
			    
				!BEST AGGREGATE SHOCK, AVERAGE IDIO SHOCK:
				iy=ny-idnint((nny-1.0_dp)/2.0_dp)
			    hprice=R(index_Ags(iy),ik)-idelta
			    inc=Wa(index_Ags(iy),ik)*zy(index_Azy(iy))*eta(age)
			 	
				!COMPUTE OPTIMAL LABOR
			    !CONSUMPTION:
		        do ib0=1,nb(1)
		            !owner
			        if (pol_h(age,ih0,ib0,iy,ik)>1) then
			            Co1(ib0)=dmax1(-b(ib0,1)*(R(index_Ags(iy),ik)+ind_b(ib0,index_beta(iy))*rpremium)+h(ih0,1)*idelta+&
			            inc*lbar+b(pol_b(age,ih0,ib0,iy,ik),1)-h(pol_h(age,ih0,ib0,iy,ik),1)-tax,cmin)/itau(age)
			            if (dabs(h(pol_h(age,ih0,ib0,iy,ik),1)/h(ih0,1)-1.0_dp)>frach) then
				        Co1(ib0)=dmax1(cmin,Co1(ib0)-costh*h(ih0,1)/itau(age))
				        endif 
				    !renter      		
			        else
			        Co1(ib0)=dmax1(-b(ib0,1)*(R(index_Ags(iy),ik)+ind_b(ib0,index_beta(iy))*rpremium)+h(ih0,1)*(idelta-costh)+&
			            inc*lbar+b(pol_b(age,ih0,ib0,iy,ik),1)-tax,cmin)/(itau(age)+whouse(age))
				    endif 
				enddo     
				pol_l1(:)=dmax1(0.001_dp,lbar-tau(age)*Co1(:)/inc)  
				
			 	write (91412,'(I3)') (pol_b(age,ih0,1:nb(1),iy,ik))
				write (91512,'(I3)') (pol_h(age,ih0,1:nb(1),iy,ik))
				write (91612,'(f16.4)') (pol_l1(:))
				
				!AVERAGE SHOCKS:
				iy=idnint((ny+1.0_dp)/2.0_dp)
			    hprice=R(index_Ags(iy),ik)-idelta
			    inc=Wa(index_Ags(iy),ik)*zy(index_Azy(iy))*eta(age)
			 	
				!COMPUTE OPTIMAL LABOR
			    !CONSUMPTION:
			    !owner
			    !CONSUMPTION:
		        do ib0=1,nb(1)
		            !owner
			        if (pol_h(age,ih0,ib0,iy,ik)>1) then
			            Co1(ib0)=dmax1(-b(ib0,1)*(R(index_Ags(iy),ik)+ind_b(ib0,index_beta(iy))*rpremium)+h(ih0,1)*idelta+&
			            inc*lbar+b(pol_b(age,ih0,ib0,iy,ik),1)-h(pol_h(age,ih0,ib0,iy,ik),1)-tax,cmin)/itau(age)
			            if (dabs(h(pol_h(age,ih0,ib0,iy,ik),1)/h(ih0,1)-1.0_dp)>frach) then
				        Co1(ib0)=dmax1(cmin,Co1(ib0)-costh*h(ih0,1)/itau(age))
				        endif 
				    !renter      		
			        else
			        Co1(ib0)=dmax1(-b(ib0,1)*(R(index_Ags(iy),ik)+ind_b(ib0,index_beta(iy))*rpremium)+h(ih0,1)*(idelta-costh)+&
			            inc*lbar+b(pol_b(age,ih0,ib0,iy,ik),1)-tax,cmin)/(itau(age)+whouse(age))
				    endif 
				enddo     
				pol_l1(:)=dmax1(0.001_dp,lbar-tau(age)*Co1(:)/inc)  
				
			 	write (91414,'(I3)') (pol_b(age,ih0,1:nb(1),iy,ik))
				write (91514,'(I3)') (pol_h(age,ih0,1:nb(1),iy,ik))
				write (91614,'(f16.4)') (pol_l1(:))
			enddo

			!PATIENT GUY

			do ih0=1,nh(2)
				!WORST AGGREGATE SHOCK, AVERAGE IDIO SHOCK:
				iy=ny+idnint((nny+1.0_dp)/2.0_dp)
			    hprice=R(index_Ags(iy),ik)-idelta
			    inc=Wa(index_Ags(iy),ik)*zy(index_Azy(iy))*eta(age)
			 	
				!COMPUTE OPTIMAL LABOR
			    !CONSUMPTION:
		        do ib0=1,nb(2)
		            !owner
			        if (pol_h(age,ih0,ib0,iy,ik)>1) then
			            Co2(ib0)=dmax1(-b(ib0,2)*(R(index_Ags(iy),ik)+ind_b(ib0,index_beta(iy))*rpremium)+h(ih0,2)*idelta+&
			            inc*lbar+b(pol_b(age,ih0,ib0,iy,ik),2)-h(pol_h(age,ih0,ib0,iy,ik),2)-tax,cmin)/itau(age)
			            if (dabs(h(pol_h(age,ih0,ib0,iy,ik),2)/h(ih0,2)-1.0_dp)>frach) then
				        Co2(ib0)=dmax1(cmin,Co2(ib0)-costh*h(ih0,2)/itau(age))
				        endif 
				    !renter      		
			        else
			        Co2(ib0)=dmax1(-b(ib0,2)*(R(index_Ags(iy),ik)+ind_b(ib0,index_beta(iy))*rpremium)+h(ih0,2)*(idelta-costh)+&
			            inc*lbar+b(pol_b(age,ih0,ib0,iy,ik),2)-tax,cmin)/(itau(age)+whouse(age))
				    endif 
				enddo     
				pol_l2(:)=dmax1(0.001_dp,lbar-tau(age)*Co2(:)/inc)  
			 	write (91411,'(I3)') (pol_b(age,ih0,1:nb(2),iy,ik))
				write (91511,'(I3)') (pol_h(age,ih0,1:nb(2),iy,ik))
				write (91611,'(f16.4)') (pol_l2(:))
				
				!BEST AGGREGATE SHOCK, AVERAGE IDIO SHOCK:
				iy=ny*2-idnint((nny-1.0_dp)/2.0_dp)
			    hprice=R(index_Ags(iy),ik)-idelta
			    inc=Wa(index_Ags(iy),ik)*zy(index_Azy(iy))*eta(age)
			 	
				!COMPUTE OPTIMAL LABOR
			    !CONSUMPTION:
		        do ib0=1,nb(2)
		            !owner
			        if (pol_h(age,ih0,ib0,iy,ik)>1) then
			            Co2(ib0)=dmax1(-b(ib0,2)*(R(index_Ags(iy),ik)+ind_b(ib0,index_beta(iy))*rpremium)+h(ih0,2)*idelta+&
			            inc*lbar+b(pol_b(age,ih0,ib0,iy,ik),2)-h(pol_h(age,ih0,ib0,iy,ik),2)-tax,cmin)/itau(age)
			            if (dabs(h(pol_h(age,ih0,ib0,iy,ik),2)/h(ih0,2)-1.0_dp)>frach) then
				        Co2(ib0)=dmax1(cmin,Co2(ib0)-costh*h(ih0,2)/itau(age))
				        endif 
				    !renter      		
			        else
			        Co2(ib0)=dmax1(-b(ib0,2)*(R(index_Ags(iy),ik)+ind_b(ib0,index_beta(iy))*rpremium)+h(ih0,2)*(idelta-costh)+&
			            inc*lbar+b(pol_b(age,ih0,ib0,iy,ik),2)-tax,cmin)/(itau(age)+whouse(age))
				    endif 
				enddo     
				pol_l2(:)=dmax1(0.001_dp,lbar-tau(age)*Co2(:)/inc)  
				
			 	write (91413,'(I3)') (pol_b(age,ih0,1:nb(2),iy,ik))
				write (91513,'(I3)') (pol_h(age,ih0,1:nb(2),iy,ik))
				write (91613,'(f16.4)') (pol_l2(:))
				
				!AVERAGE SHOCKS:
				iy=ny+idnint((ny+1.0_dp)/2.0_dp)
			    hprice=R(index_Ags(iy),ik)-idelta
			    inc=Wa(index_Ags(iy),ik)*zy(index_Azy(iy))*eta(age)
			 	
				!COMPUTE OPTIMAL LABOR
			    !CONSUMPTION:
		        do ib0=1,nb(2)
		            !owner
			        if (pol_h(age,ih0,ib0,iy,ik)>1) then
			            Co2(ib0)=dmax1(-b(ib0,2)*(R(index_Ags(iy),ik)+ind_b(ib0,index_beta(iy))*rpremium)+h(ih0,2)*idelta+&
			            inc*lbar+b(pol_b(age,ih0,ib0,iy,ik),2)-h(pol_h(age,ih0,ib0,iy,ik),2)-tax,cmin)/itau(age)
			            if (dabs(h(pol_h(age,ih0,ib0,iy,ik),2)/h(ih0,2)-1.0_dp)>frach) then
				        Co2(ib0)=dmax1(cmin,Co2(ib0)-costh*h(ih0,2)/itau(age))
				        endif 
				    !renter      		
			        else
			        Co2(ib0)=dmax1(-b(ib0,2)*(R(index_Ags(iy),ik)+ind_b(ib0,index_beta(iy))*rpremium)+h(ih0,2)*(idelta-costh)+&
			            inc*lbar+b(pol_b(age,ih0,ib0,iy,ik),2)-tax,cmin)/(itau(age)+whouse(age))
				    endif 
				enddo     
				pol_l2(:)=dmax1(0.001_dp,lbar-tau(age)*Co2(:)/inc)  
			 	write (91415,'(I3)') (pol_b(age,ih0,1:nb(2),iy,ik))
				write (91515,'(I3)') (pol_h(age,ih0,1:nb(2),iy,ik))
				write (91615,'(f16.4)') (pol_l2(:))
			enddo

			close (unit = 91410)
			close (unit = 91411)
			close (unit = 91412)
			close (unit = 91413)
			close (unit = 91414)
			close (unit = 91415)
			close (unit = 91510)
			close (unit = 91511)
			close (unit = 91512)
			close (unit = 91513)
			close (unit = 91514)
			close (unit = 91515)
			close (unit = 91610)
			close (unit = 91611)
			close (unit = 91612)
			close (unit = 91613)
			close (unit = 91614)
			close (unit = 91615)

	enddo !end age


END SUBROUTINE value_iter